window.dataStore = {};

dataStore = Object.freeze(dataStore);

Object.unfreeze=function(o){
   let oo=undefined;
		if( o instanceof Array){
			oo=[];
			let clone=function(v){oo.push(v)};
			o.forEach(clone);
		}else if(o instanceof String){
			oo=new String(o).toString();
		}else  if(typeof o =='object'){
			oo={};
			for (let property in o){
				oo[property] = o[property];
			}
		}
		return oo;
 }

export function create(storeName) {
	dataStore = Object.unfreeze(dataStore);
	dataStore[storeName] = {};
	dataStore = Object.freeze(dataStore);
	return dataStore[storeName];
}

export function insert(storeName, object) {
	dataStore = Object.unfreeze(dataStore);
	if (typeof dataStore[storeName] !== 'undefined') {
		dataStore[storeName] = object;
	} else {
		throw storeName + ' is not empty! Use "set" for setting a value';
	}
	dataStore = Object.freeze(dataStore);
	return dataStore[storeName];
}

export function empty(storeName, key) {
	dataStore = Object.unfreeze(dataStore);
	dataStore[storeName][key] = '';
	dataStore = Object.freeze(dataStore);
	return dataStore[storeName];
};

export function remove(storeName, key) {
	dataStore = Object.unfreeze(dataStore);
	delete dataStore[storeName][key];
	dataStore = Object.freeze(dataStore);

	return dataStore[storeName];
}

export function destroy(storeName) {
	dataStore = Object.unfreeze(dataStore);
	delete dataStore[storeName];
	dataStore = Object.freeze(dataStore);

	return dataStore;
}

export function get(storeName, key) {
	return dataStore[storeName][key];
}

export function set(storeName, key, value) {
	dataStore = Object.unfreeze(dataStore);
	dataStore[storeName][key] = value;
	dataStore = Object.freeze(dataStore);

	return dataStore[storeName];
}

export function list(storeName) {
	return dataStore[storeName];
}

let compare = {
	'gt': function(a, b) { return a > b },
	'lt': function(a, b) { return a < b },
	'gte': function(a, b) { return a >= b },
	'lte': function(a, b) { return a <= b },
	'eq': function(a, b) { return a == b },
}

export function find(storeName, query) {
	let operator = 'eq';
	let value = query;
	let result = [];

	if (typeof query == 'object') {
		operator = Object.keys(query)[0];
		value = query[operator];
	}

	for (key in dataStore[storeName]) {
		if (compare[operator](dataStore[storeName][key], value)) {
			let doc = {};
			doc[key] = dataStore[storeName][key];
			result.push(doc);
		}
	}

	return result;
}

export function findOne(storeName, query) {
	let operator = 'eq';
	let value = query;
	let result = [];

	if (typeof query == 'object') {
		operator = Object.keys(query)[0];
		value = query[operator];
	}

	for (key in dataStore[storeName]) {
		if (compare[operator](dataStore[storeName][key], value)) {
			let doc = {};
			doc[key] = dataStore[storeName][key];
			return doc;
		}
	}

	return false;
}
