window.dataStore = {};

dataStore = Object.freeze(dataStore);

Object.unfreeze=function(o){
   let oo=undefined;
		if( o instanceof Array){
			oo=[];
			let clone=function(v){oo.push(v)};
			o.forEach(clone);
		}else if(o instanceof String){
			oo=new String(o).toString();
		}else  if(typeof o =='object'){
			oo={};
			for (let property in o){
				oo[property] = o[property];
			}
		}
		return oo;
 }

function create(storeName) {
	dataStore = Object.unfreeze(dataStore);
	dataStore[storeName] = {};
	dataStore = Object.freeze(dataStore);
	return dataStore[storeName];
}

function insert(storeName, object) {
	dataStore = Object.unfreeze(dataStore);
	if (typeof dataStore[storeName] !== 'undefined') {
		dataStore[storeName] = object;
	} else {
		throw storeName + ' is not empty! Use "set" for setting a value';
	}
	dataStore = Object.freeze(dataStore);
	return dataStore[storeName];
}

function empty(storeName, key) {
	dataStore[storeName][key] = '';

	return dataStore[storeName];
};

function remove(storeName, key) {
	delete dataStore[storeName][key];

	return dataStore[storeName];
}

function destroy(storeName) {
	delete dataStore[storeName];

	return dataStore;
}

function get(storeName, key) {
	return dataStore[storeName][key];
}

function set(storeName, key, value) {
	dataStore[storeName][key] = value;

	return dataStore[storeName];
}

function list(storeName) {
	return dataStore[storeName];
}

let compare = {
	'gt': function(a, b) { return a > b },
	'lt': function(a, b) { return a < b },
	'gte': function(a, b) { return a >= b },
	'lte': function(a, b) { return a <= b },
	'eq': function(a, b) { return a == b },
}

function find(storeName, query) {
	let operator = 'eq';
	let value = query;
	let result = [];

	if (typeof query == 'object') {
		operator = Object.keys(query)[0];
		value = query[operator];
	}

	for (key in dataStore[storeName]) {
		if (compare[operator](dataStore[storeName][key], value)) {
			let doc = {};
			doc[key] = dataStore[storeName][key];
			result.push(doc);
		}
	}

	return result;
}

function findOne(storeName, query) {
	let operator = 'eq';
	let value = query;
	let result = [];

	if (typeof query == 'object') {
		operator = Object.keys(query)[0];
		value = query[operator];
	}

	for (key in dataStore[storeName]) {
		if (compare[operator](dataStore[storeName][key], value)) {
			let doc = {};
			doc[key] = dataStore[storeName][key];
			return doc;
		}
	}

	return false;
}

export { create, insert, empty, remove, destroy, get, set, list, find, findOne };